/**
* Created by 陈维斌 on 2016/12/21.
* update by 陈维斌  
* 添加轮次和条件查询 
* 将桌面版左右的活动详情合并成一个查询文件
*/

var pageIndex = 0; //页索引
var pageSize = 8; //每页显示的条数
var dataCount = 1; //总条目数	必选参数，整数 ajax 时通过 返回的参数确定
var first_flag = false; //是否第一次加载
var currentPage = 0;

$(document).ready(function () {
    selectButtonontrol()
    getDateBySelectButton()

    /*
    *点击检索按钮事件
    */
    $("#J-search-art").click(function () {
        $(".J-detail-vote-block").html("");
        // 这里重新调用数据方法
        //$("#" + $(this).attr("targetId")).val($(this).attr("data"));
        event.stopPropagation();
        pageIndex = 0;
        first_flag = false;
        getData(0);
    });

    if (type && type == "2") {
        $("#J-activity-control-button2").click();
    }

    $("#ItemName").keydown(function () {
        if (event.keyCode == "13") {//keyCode=13是回车键
            $("#J-search-art").click();
        }
    });

    //数据加载
    getData(pageIndex);

});


function PageCallback(jumpindex) {
    if (pageIndex == 0 && !first_flag) { //查询第一页并进行分页初始化时，不去服务器再次查询
        first_flag = true;
    } else {
        getData(jumpindex);
    }
    currentPage = jumpindex;
    return false;
};

function initPagination() {
    if (pageIndex == 0 && !first_flag) { //查询第一也是进行初始化
        $("#a-vote-Pagination").pagination(dataCount, {
            num_edge_entries: 1, //两侧显示的首尾分页的条目数	可选参数，默认是0
            num_display_entries: 4, //连续分页主体部分显示的分页条目数	可选参数，默认是10
            callback: PageCallback,
            prev_text: '上一页',
            next_text: '下一页',
            items_per_page: pageSize,
            current_page: pageIndex
        });
    }
};


$(window).scroll(function () {
    var sidebarHeight = 0;
    var windowHeight = $(document).scrollTop() - sidebarHeight;
    if ($(document).scrollTop() >= $(document).height() - $(window).height()) {
        var totalPage = parseInt((dataCount + pageSize - 1) / pageSize);
        if (parseInt(currentPage + 1) < totalPage) {
            $("#a-vote-Pagination").trigger('nextPage');
            $(".p-down").show();
            $(".p-warn").hide();
        } else {
            $(".p-down").hide();
            $(".p-warn").show();
        }
    }
});

function getData(pageIndex) {
    //    $(".pageindex").html("@"+$(".pageindex").html()+"/"+pageIndex);
    //ajax加载 每次需要将总页数传递过来 pageCount
    $.ajax({
        dataType: "json",
        type: "POST",
        url: '../../APIActivity/GetVoteArtistList',
        data: "pageIndex=" + (pageIndex + 1) + "&pageSize=" + pageSize + "&VID=" + $("#MainId").val() + "&itemRound=" + ($("#Round").val() || "") + "&ItemName=" + $("#ItemName").val() + "&Categray2=" + $("#Categray2").val(),
        async: true,
        timeout: 25000,
        beforeSend: function (XMLHttpRequest) {
            //var index = layer.load(2, { shade: [0.3, '#86a5ad'] });
        },
        success: function (msg) {
            if (msg != "") {
                var data = msg.Data;

                var html = "";
                var currentIndex = 0;
                var columns = 4; // 要显示的列数

                dataCount = msg.DataCount;
                var pageDataCount = data.length;
                var rows = ((pageDataCount % columns) == 0) ? parseInt(pageDataCount / columns) : parseInt(pageDataCount / columns) + 1;  // 要显示的行数
                initPagination();
                for (var row = 0; row < rows; row++) {
                    var currenColumn = (pageDataCount - columns * row);
                    currenColumn = currenColumn > columns ? columns : currenColumn

                    html += '<div class="row">';
                    for (var col = 0; col < currenColumn; col++) {

                        var index = row * columns + col;
                        if (index >= data.length) {
                            continue;
                        }
                        var item = data[index];
                        html += '<div class="bit-' + columns + '" style=" padding: 5px !important;">';
                        html += '<div class="activity-art-card">';
                        html += '<div class="activity-art-card-image">';

                        html += '<a title="' + item.ItemName + '" href="/Activity/ActivityPage/ActivityVoteRankingDetailed?vid=' + item.VID + '&viid=' + item.VIID + '&round=' + ($("#Round").val() || "1") + '" style="background-image:url(' + item.ImgUrl + '?x-oss-process=image/auto-orient,1' + ');padding:10px; border:1px solid #E5E5E5;" class="activity-art-card-image--img">';
                        html += '<div class="autoHeight"></div>';
                        html += '</a>';


                        var len = 10;
                        var replacestr = "…";
                        var str1 = item.Size || "";
                        if (str1.length > len) {
                            str1 = str1.substring(0, len) + replacestr;
                        }

                        if (item.ItemCode == null || !item.ItemCode) {
                            item.ItemCode = "";
                        }

                        html += '<div class="activity-art-card-image--content" data-id="' + item.VIID + '">';
                        html += '<div class="activity-art-card-image--title" style="    font-weight:bold; "><span>编号：</span><span>' + item.ItemCode + '</span></div>';
                        html += '<div class="activity-art-card-image--title" style="    margin-top: 10px; ">' + item.ItemName + '</div>';
                        html += '<div class="activity-art-card-image--item"><span>规格：</span><span>' + str1 + '</span></div>';
                        html += '<div class="activity-art-card-image--item"><div class="activity-art-card-image--item-group"><span>类型：</span><span>' + item.CategrayName + '</span></div></div>';

                        html += '<div class="activity-art-card-image--item activity-art-card-image--follow">';

                        if (progress == 1) { //正在征集
                            html += '<div class="activity-art-card-image--item-group">';
                            html += '<div class="button" onclick="javascript:VoteItemAgreeAgree(\'' + item.VIID + '\')"><span class="icon-follow1"></span><span class="Agreenum">' + item.Agreenum + '</span></div>';
                            html += '</div>';
                        } else if (progress == 2) { //正在投票
                            html += '<div class="activity-art-card-image--item-group"><div class="button" onclick="javascript:vote(\'' + item.VIID + '\',\'' + item.itemRoundId + '\')">投一票</div></div>';
                            html += '<div class="activity-art-card-image--item-group"><span class="icon-like1"></span><span class="votenum">' + item.voterecordcount + '</span></div>';
                        } else if (progress == 3) { //征集历史
                            html += '<div class="activity-art-card-image--item-group">';
                            html += '<div class="button"><span>' + item.voterecordcount + '票</span></div>';
                            html += '</div>';
                        }

                        html += '</div>';
                        html += '</div>';
                        html += '</div>';
                        html += '</div>';
                        html += '</div>';
                    }
                    html += '</div>';
                }
                $(".J-detail-vote-block").append(html); //将返回的数据追加页面
            }
            //layer.close(layer.index);
        },
        complete: function (XMLHttpRequest, textStatus) {
            //layer.close(layer.index);
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
            //layer.close(layer.index);
        }
    });
}

/*
*加载每轮活动公告
*/
function GetRoundIntroduction() {
    $.ajax({
        dataType: "json",
        type: "POST",
        url: '../../APIActivity/Get_ActivityVoteRound',
        data: "activityId=" + $("#MainId").val() + "&round=" + ($("#Round").val() || ""),
        success: function (msg) {
            $("div[id='voteRoundText']").html(msg.RoundIntroduction);
        }
    });
}

/*
*切换投票轮次查询参赛作品
*/
function getDateBySelectButton() {
    var allbtn = $("li.J-selectButton-child")
    if (allbtn.length && allbtn.length > 0) {
        allbtn.click(function () {
            $(".J-detail-vote-block").html("");

            $(".J-selectButton-child").removeClass("li-active");
            $(this).addClass("li-active");
            var parWin = $(this).parents(".J-selectButton");
            //$(this).parent().parent().parent().parent()
            $(".J-selectButtonText", parWin).html($(this).html());
            parWin.removeClass("dropdown-menu-active");

            // 这里重新调用数据方法
            $("#" + $(this).attr("targetId")).val($(this).attr("data"));
            event.stopPropagation();
            pageIndex = 0;
            first_flag = false;
            getData(0);
        });
    } else {
        return false
    }
}

/*
*作品投票
*/
function vote(viid, itemRoundId) {
    alert(itemRoundId);
    confirm('确认对该作品投票？', function (flag) {
        if (flag) {
            $.ajax({
                dataType: "json",
                type: "POST",
                url: RootPath() + '/APIActivity/Vote',
                data: "viid=" + viid + "&itemRoundId=" + itemRoundId,
                success: function (data) {
                    if (data.IsSuccess) {
                        var votepanel = $("span.votenum", $("div[data-id='" + viid + "']")).html();
                        $("span.votenum", $("div[data-id='" + viid + "']")).html(parseInt(votepanel) + 1);
                        alert(data.Message);
                    }
                    else {
                        if (data.DataCount == -1) {
                            window.location.href = "/VIPMember/Member/UserLogin?redirect=" + encodeURIComponent(window.location.href);
                        } else {
                            alert(data.Message);
                        }
                    }
                }
            });
        }
    })
}
/*
* 作品点赞
*/
function VoteItemAgreeAgree(viId) {
    $.ajax({
        dataType: "json",
        type: "POST",
        url: '../../APIActivity/VoteItemAgreeAgree',
        data: "Viid=" + viId,
        success: function (data) {
            switch (data) {
                case 1:
                    var agreenum = $("span.Agreenum", $("div[data-id='" + viId + "']")).html();
                    $("span.Agreenum", $("div[data-id='" + viId + "']")).html(parseInt(agreenum) + 1);
                    alert("关注成功");
                    //数据加载
                    //getData(currentPage);
                    //location.reload();
                    break;
                case 0:
                    alert("提交失败");
                    break;
                case -1:
                    window.location.href = "/VIPMember/Member/UserLogin?redirect=" + encodeURIComponent(window.location.href);
                    break;
                case -2:
                    alert("你已关注了该作品");
                    break;
                default:
                    break;
            }
        }
    });
}